import 'package:shared_preferences/shared_preferences.dart';
import 'package:uuid/uuid.dart';

class PhrasePrefs{

  static const String _KEY_UUID = "phrase_uuid";
  static const String _KEY_LAST_UPDATE = "phrase_last_update";
  String _keyTranslationVer(String localeHash) => "phrase_version_$localeHash";

  Future<String?> _get(String key) async{
    SharedPreferences prefs = await SharedPreferences.getInstance();
    return prefs.getString(key);
  }

  Future<void> _put(String key, String value) async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    await prefs.setString(key, value);
  }

  Future<String> getUUID() async {
    String? uuid = await _get(_KEY_UUID);
    if(uuid!=null) return uuid;
    uuid = Uuid().v4();
    await _put(_KEY_UUID, uuid);
    return uuid;
  }

  Future<String?> getLastUpdate() => _get(_KEY_LAST_UPDATE);
  Future<void> setLastUpdate() => _put(_KEY_LAST_UPDATE, (DateTime.now().millisecondsSinceEpoch/1000).round().toString());
  Future<String?> getVersion(String localeHash) => _get(_keyTranslationVer(localeHash));
  Future<void> setVersion(String localeHash, String version) => _put(_keyTranslationVer(localeHash), version);

}